<div class="container mt-4">
  <div class="row">
    <div class="col-6">
      <div class="card">
        <div class="card-header bg-info text-light">
          <h3>Car Makes</h3>
        </div>
        <div class="card-body" id="carMakeList">
          <ul class="list-group">
            <li class="list-group-item list-group-item-action" [class.active]="selectedMakeId === make.id" *ngFor="let make of carMakes; let i = index"
              (click)="onMakeClick(i)">
              <h5>{{make.name}}</h5>
            </li>
          </ul>
        </div>
        <div class="card-footer">
          <ng-container *ngIf="selectedMakeId != null">
            <div class="row">
              <div class="col-2">
                <button class="btn btn-danger" (click)="open(deleteMake)">
                  Delete
                </button>
              </div>
              <div class="col-3">
                <button class="btn btn-primary" (click)="open(addCar)">Add Car</button>
              </div>
              <div class="col-4"></div>
              <div class="col-3">
                <button class="btn btn-success" (click)="open(addMake)">Add Make</button>
              </div>
            </div>
          </ng-container>
          <ng-container *ngIf="selectedMakeId == null">
            <div class="row">
              <button class="btn btn-success" (click)="open(addMake)">Add Make</button>
            </div>
          </ng-container>
        </div>
      </div>
    </div>
    <div class="col-6">
      <div class="card">
        <div class="card-header bg-info text-light">
          <h3>Car Models</h3>
        </div>
        <div class="card-body">
          <li class="list-group-item list-group-item-action" *ngFor="let car of carModels; let i = index" (click)="onModelClick(i)">
            <div class="row">
              <div class="col-6">
                <h5>{{car.name}}</h5>
              </div>
              <div class="col-5"></div>
              <div class="col-1">
                <i class="far fa-trash-alt text-danger" ngbTooltip="Remove" (click)=open(content);deleteModelSelect(i)></i>
              </div>
            </div>
          </li>
          <li *ngIf="selectedMakeId == null" class="list-group-item bg-primary text-light">
            <h5>Please select make</h5>
          </li>
          <li *ngIf="carModels.length === 0 && selectedMakeId != null" class="list-group-item bg-warning">
            <h5 class="text-dark">No cars for selected models <i class="fas fa-exclamation-triangle"></i></h5>
          </li>
        </div>
      </div>
    </div>
  </div>
</div>

<ng-template #content let-c="close" let-d="dismiss">
  <div class="modal-header bg-danger">
    <h4 class="modal-title text-light" id="modal-basic-title">Delete</h4>
    <button type="button" class="close" aria-label="Close" (click)="d('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <h5>Are you sure you want to delete: {{selectedCarModel?.name}} ?</h5>
  </div>
  <div class="modal-footer">
    <div class="row">
      <div class="col-6">
        <button type="button" class="btn btn-danger" (click)="deleteModel();c()">Delete</button>
      </div>
      <div class="col-6">
        <button type="button" class="btn btn-default" (click)="c()">Cancel</button>
      </div>
    </div>

  </div>
</ng-template>

<ng-template #deleteMake let-c="close" let-d="dismiss">
  <div class="modal-header bg-danger">
    <h4 class="modal-title text-light" id="modal-basic-title">Delete</h4>
    <button type="button" class="close" aria-label="Close" (click)="d('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <h5>Are you sure you want to delete?</h5>
  </div>
  <div class="modal-footer">
    <div class="row">
      <div class="col-6">
        <button type="button" class="btn btn-danger" (click)="deleteSelectedMake();c()">Delete</button>
      </div>
      <div class="col-6">
        <button type="button" class="btn btn-default" (click)="c()">Cancel</button>
      </div>
    </div>

  </div>
</ng-template>


<ng-template #addMake let-c="close" let-d="dismiss">
  <div class="modal-header">
    <h4 class="modal-title" id="modal-basic-title">Add Make</h4>
    <button type="button" class="close" aria-label="Close" (click)="d('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <form #makeForm="ngForm">
      <div class="form-group">
        <label for="make">Name</label>
        <input type="text" class="form-control" name="make" placeholder="Enter make name" [(ngModel)]="makeAdd.name"
          #make="ngModel" required>
        <p class="text-danger" *ngIf="make.invalid && (make.dirty || make.touched)">Field cannot be empty</p>

      </div>
    </form>
  </div>
  <div class="modal-footer">
    <div class="row">
      <div class="col-6">
        <button type="button" class="btn btn-success" (click)="c();addNewMake()" [disabled]="makeForm.invalid">Confirm</button>
      </div>
      <div class="col-6">
        <button type="button" class="btn btn-secondary" (click)="c()">Cancel</button>
      </div>
    </div>

  </div>
</ng-template>

<ng-template #addCar let-c="close" let-d="dismiss">
  <div class="modal-header">
    <h4 class="modal-title" id="modal-basic-title">Add Car</h4>
    <button type="button" class="close" aria-label="Close" (click)="d('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <form #modelForm="ngForm">
      <div class="form-group">
        <label for="carModel">Model name</label>
        <input type="text" class="form-control" name="carModel" placeholder="Enter car name" [(ngModel)]="carAdd.name" #carModel="ngModel" required>
        <p class="text-danger" *ngIf="carModel.invalid && (carModel.dirty || carModel.touched)">Field cannot be empty</p>

      </div>
    </form>
  </div>
  <div class="modal-footer">
    <div class="row">
      <div class="col-6">
        <button type="button" class="btn btn-success" (click)="c();addNewCar()" [disabled]="modelForm.invalid">Confirm</button>
      </div>
      <div class="col-6">
        <button type="button" class="btn btn-secondary" (click)="c()">Cancel</button>
      </div>
    </div>

  </div>
</ng-template>